<?php

//  Copyright (C) 2016 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/print.printer.php";

// Disable compression
$compress_pages = false;

// let page run until completion
set_time_limit(0);
ini_set("max_execution_time", 0);

// Try to turn off caching
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

$count = 0;
$database = site_prolog(PO_USER_TYPE_USER);

# Whee!
$printer_name = $_REQUEST['printer'];

/*----------*/
/* Make sure permissions allow this */
if (!$local_printing ||
    $po_options['local_print'] != 't') {  
  site_epilog($database);
  header("Location: $_SERVER[HTTP_REFERER]");
  exit();
}

/* Sanity Check */
if (!array_key_exists($printer_name, $po_options['printers'])) {
  site_push_error($strings['print_invalid']);
  site_epilog($database);
  header("Location: $_SERVER[HTTP_REFERER]");
  exit();
}
$printer = $po_options['printers'][$printer_name];

if (isset($_REQUEST['photo_id']) && isset($_REQUEST['version_id'])) {
  $version         = pg_escape_string($database, $_REQUEST['version_id']);
  $photo           = pg_escape_string($database, $_REQUEST['photo_id']);
  site_push_error(sprintf($strings['print_queueing'], "$photo:$version", "$printer_name")."\n");
  photo_print_queue_one($database, $photo, $version, $printer);
  site_epilog($database);
  header("Location: $_SERVER[HTTP_REFERER]");  
  exit();
}

/* Get list of photos to print */
$photos_in_spooler = pg_query($database, "
  select photo, version from album_content where album = $po_user[spool_album] group by photo, version order by photo, version");

$num_photos = pg_num_rows($photos_in_spooler);

for ($index = 0; $index < $num_photos; $index++) {
  $row = pg_fetch_assoc($photos_in_spooler, $index);

  site_push_error(sprintf($strings['print_queueing'], "$row[photo]:$row[version]", "$printer_name")."\n");
  photo_print_queue_one($database, $row['photo'], $row['version'], $printer);
  
  $count++;			    
}
site_push_error("$count ".$strings['print_all_queued']);

if (!$external_workers) {
  site_push_error(photo_print_worker($database, $po_user['id'], FALSE));
}

site_epilog($database);
header("Location: $_SERVER[HTTP_REFERER]");  
exit();

?>
