--  Copyright (c) 2007 Solomon Peachy (pizza@shaftnet.org)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.35.A to 2.35.B patch 
----------------------------------------------------------

-- Drop a useless column and its sequence.
alter table album_content drop COLUMN identifier;
drop sequence album_content_id_sequence;


-- Fix bugs in the can_access_* functions

CREATE OR REPLACE FUNCTION can_access_album(integer, integer, character varying[]) RETURNS boolean
    AS ' DECLARE res_id alias for $1; user_id alias for $2; passwd_list alias for $3; res_access integer; owns_id integer; can_access boolean; admin_type boolean; passwd varchar; BEGIN     SELECT INTO res_access, owns_id, passwd access_rights, users, password FROM album WHERE identifier = res_id;  IF res_access = 1 THEN RETURN true; END IF;  IF owns_id = user_id THEN RETURN true; END IF;  SELECT INTO admin_type true FROM users WHERE identifier = user_id AND type = 4; IF admin_type is true THEN RETURN true; END IF;  IF res_access = 2 THEN SELECT INTO can_access true FROM album, calendar WHERE album.event = calendar.identifier AND album.identifier = res_id AND calendar.client = user_id;  IF can_access is true THEN RETURN true; END IF;  SELECT INTO can_access true FROM album WHERE album.identifier = res_id AND passwd = ANY(passwd_list); IF can_access is true THEN RETURN true; END IF; END IF;  return false; END; '
    LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION can_access_folder(integer, integer, character varying[]) RETURNS boolean
    AS ' DECLARE res_id alias for $1; user_id alias for $2; passwd_list alias for $3; res_access integer; owns_id integer; can_access boolean; admin_type boolean; passwd varchar; BEGIN     SELECT INTO res_access, owns_id, passwd access_rights, users, password FROM folder WHERE identifier = res_id;  IF res_access = 1 THEN RETURN true; END IF;  IF owns_id = user_id THEN RETURN true; END IF;  SELECT INTO admin_type true FROM users WHERE identifier = user_id AND type = 4; IF admin_type is true THEN RETURN true; END IF;  IF res_access = 2 THEN SELECT INTO can_access true FROM folder, calendar WHERE folder.event = calendar.identifier AND folder.identifier = res_id AND calendar.client = user_id;  IF can_access is true THEN RETURN true; END IF;  SELECT INTO can_access true FROM folder WHERE folder.identifier = res_id AND passwd = ANY(passwd_list); IF can_access is true THEN RETURN true; END IF; END IF;  return false; END; '
    LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION can_access_photo(integer, integer, character varying[]) RETURNS boolean
    AS ' DECLARE res_id alias for $1; user_id alias for $2; passwd_list alias for $3; res_access integer; owns_id integer; can_access boolean; admin_type boolean; BEGIN     SELECT INTO res_access, owns_id access_rights, users FROM photo WHERE identifier = res_id;  IF res_access = 1 THEN RETURN true; END IF;  IF owns_id = user_id THEN RETURN true; END IF;  SELECT INTO admin_type true FROM users WHERE identifier = user_id AND type = 4; IF admin_type is true THEN RETURN true; END IF;  IF res_access = 2 THEN SELECT INTO can_access true FROM photo, folder, calendar WHERE folder.identifier = photo.folder AND photo.identifier = res_id AND folder.event = calendar.identifier AND calendar.client = user_id; IF can_access is true THEN RETURN true; END IF;  SELECT INTO can_access true FROM photo, folder WHERE photo.identifier = res_id AND photo.folder = folder.identifier AND folder.password = ANY(passwd_list); IF can_access is true THEN RETURN true; END IF;  SELECT INTO can_access true FROM album_content, album, calendar WHERE album_content.photo = res_id AND album.identifier = album_content.album AND album.event = calendar.identifier AND calendar.client = user_id; IF can_access is true THEN RETURN true; END IF;  SELECT INTO can_access true FROM album, album_content WHERE album_content.photo = res_id AND album_content.album = album.identifier AND album.password = ANY(passwd_list); IF can_access is true THEN RETURN true; END IF;  END IF;  return false; END; '
    LANGUAGE plpgsql;

-- version update 
update version set identifier=3, description='2.35 customer release', 
 major=2, minor=35, variation='B';


