--  Copyright (c) 2007 Solomon Peachy (pizza@shaftnet.org)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.36.D to 2.37.A patch 
----------------------------------------------------------

-- These are obselete:

DROP VIEW view_contact; 
DROP VIEW view_users_subscribed_to;

-- Convert lat/lon in 'location' table to proper numeric type.

ALTER TABLE location add column lat_num numeric;
ALTER TABLE location add column lon_num numeric;

UPDATE location SET lat_num = latitude::float where latitude != '';
UPDATE location SET lon_num = longitude::float where longitude != '';

DROP VIEW view_location;

ALTER TABLE location DROP COLUMN latitude;
ALTER TABLE location DROP COLUMN longitude;
ALTER TABLE location RENAME COLUMN lat_num to latitude;
ALTER TABLE location RENAME COLUMN lon_num to longitude;

CREATE VIEW view_location AS
    SELECT "location".identifier, "location".place, "location".city,
           (SELECT state.value FROM state
             WHERE (state.identifier = "location".state)) AS state,
           (SELECT country.value FROM country
             WHERE (country.identifier = "location".country)) AS country,
           "location".users, "location".last_modified_date,
           "location".latitude, "location".longitude,
           "location".private FROM "location";

-- Add a filtered display_location

CREATE FUNCTION number_of_location_references(integer,integer) RETURNS bigint
    AS 'select count(photo.identifier) from photo, location where photo.users = $2 and photo.location=location.identifier and location.identifier = $1'
    LANGUAGE sql;

-- Delete some unused stuff

DROP OPERATOR =##=(character varying, character varying);
DROP OPERATOR ====(character varying, character varying);
DROP OPERATOR =##=(integer, character varying);
DROP OPERATOR ====(integer, character varying);
DROP FUNCTION tokenized_ilike(integer, character varying);
DROP FUNCTION tokenized_ilike(character varying, character varying);
DROP FUNCTION tokenized_like(integer, character varying);
DROP FUNCTION tokenized_like(character varying, character varying);
DROP OPERATOR ||| (character varying, character varying);
DROP FUNCTION concat_ignore_null(character varying, character varying);

-- version update 
update version set identifier=3, description='2.37 Development release', 
 major=2, minor=37, variation='A';
