--  Copyright (c) 2009 Solomon Peachy (pizza@shaftnet.org)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.37.C to 2.38.A patch 
----------------------------------------------------------

------ to deal with imports

CREATE SEQUENCE pending_prints_sequence START 1;

CREATE TABLE pending_prints (
       identifier integer NOT NULL PRIMARY KEY,
       users integer references users(identifier) NOT NULL,
       version integer references photo_version(identifier),
       print_data TEXT
);

CREATE SEQUENCE print_results_sequence START 1;

CREATE TABLE print_results (
       identifier integer NOT NULL PRIMARY KEY DEFAULT nextval('print_results_sequence'),
       users integer references users(identifier) NOT NULL,
       log_data TEXT
);

----- Nuke the entire photo_dupe infrastructure!
DROP TABLE photo_dupe;
DROP SEQUENCE photo_dupe_id_sequence;

----- Nuke labels
DROP TABLE label;
DROP SEQUENCE label_id_sequence;

-- version update 
update version set identifier=3, description='2.38 Development release', 
 major=2, minor=38, variation='A';
